#include <stdio.h>
#include <fcntl.h>

// We first open a file and then fork.
// This means that the file descriptors of parent and child point
// to the same entries in the open-file table. Thus, the read actions
// in parent and child both advance the reading position of the same file.

void do_read (char *name, int fd)
{
	char c;
	while (read(fd,&c,1))
	{
		printf("%s: %c\n",name,c);
		sleep(2);
	}
}

void main ()
{
	// Inverting these two lines means that both read accesses
	// will be independent!
	int fd = open("foo",O_RDONLY);
	int pid = fork();

	if (pid) do_read("parent",fd); else { sleep(1); do_read("child",fd); }
	close(fd);
}
